#ifndef RTW_HEADER_SOC_h_
#define RTW_HEADER_SOC_h_
#ifndef SOC_COMMON_INCLUDES_
#define SOC_COMMON_INCLUDES_
#include "rtwtypes.h"
#endif

#include "SOC_types.h"
#include "rtGetInf.h"
#include "rt_nonfinite.h"
#include "zero_crossing_types.h"

#include "BCUCal.h"
#include "BCUDisp.h"

#ifndef SOC_MDLREF_HIDE_CHILD_

typedef struct {
  real_T Subsystem1_Trig_ZC;
} ZCV_Subsystem1_SOC_T;

#endif

#ifndef SOC_MDLREF_HIDE_CHILD_

typedef struct {
  ZCSigState Subsystem1_Trig_ZCE;
} ZCE_Subsystem1_SOC_T;

#endif

#ifndef SOC_MDLREF_HIDE_CHILD_

typedef struct {
  real32_T in1;
  real32_T in2;
  real32_T in1_i;
  real32_T in2_f;
  real32_T in1_ix;
  real32_T in2_fe;
  real32_T Switch1;
  real32_T Switch;
  real32_T Divide;
  boolean_T LogicalOperator_j;
} B_SOC_c_T;

#endif

#ifndef SOC_MDLREF_HIDE_CHILD_

typedef struct {
  real_T UnitDelay_DSTATE;
  real_T UnitDelay_DSTATE_d;
  real_T UnitDelay_DSTATE_c;
  real32_T Delay_DSTATE;
  real32_T Delay_DSTATE_l;
  real32_T Delay1_DSTATE;
  real32_T P_Delay_DSTATE[4];
  real32_T Delay2_DSTATE;
  real32_T Delay1_DSTATE_a;
  real32_T P_Delay_DSTATE_k[4];
  real32_T Delay2_DSTATE_k;
  real32_T Delay1_DSTATE_n;
  real32_T socd_pct_battSoc0_Delay_DSTATE;
  real32_T socd_pct_bcuSoc0_Delay_DSTATE;
  real32_T socd_flg_EEsave_Delay_DSTATE;
  real32_T socd_flg_EEsave_Delay1_DSTATE;
  real32_T UnitDelay1_DSTATE;
  real32_T UnitDelay_DSTATE_o;
  real32_T UnitDelay1_DSTATE_h;
  real32_T Delay_DSTATE_f[10];
  real32_T UnitDelay_DSTATE_i;
  real32_T UnitDelay2_DSTATE;
  real32_T UnitDelay3_DSTATE;
  real32_T UnitDelay1_DSTATE_a;
  real32_T Delay_DSTATE_lp[10];
  real32_T Delay_DSTATE_h;
  real32_T Delay_DSTATE_h0;
  real32_T UnitDelay_DSTATE_b;
  real32_T Divide_DWORK4;
  real32_T Divide_DWORK4_l;
  uint16_T UnitDelay_DSTATE_n;
  uint16_T UnitDelay_DSTATE_m;
  uint16_T UnitDelay_DSTATE_p;
  uint16_T UnitDelay_DSTATE_ol;
  uint16_T UnitDelay_DSTATE_o2;
  uint16_T UnitDelay_DSTATE_dx;
  uint16_T UnitDelay_DSTATE_h;
  uint16_T UnitDelay5_DSTATE;
  uint16_T UnitDelay5_DSTATE_k;
  boolean_T UnitDelay_DSTATE_ca;
  boolean_T UnitDelay_DSTATE_f;
  boolean_T UnitDelay_DSTATE_fs;
  boolean_T UnitDelay_DSTATE_e;
  chrgSt Delay2_DSTATE_b;
  int8_T If_ActiveSubsystem;
  int8_T If_ActiveSubsystem_j;
  boolean_T icLoad;
  boolean_T icLoad_j;
  boolean_T icLoad_o;
  boolean_T icLoad_i;
  boolean_T icLoad_p;
  boolean_T icLoad_a;
  boolean_T icLoad_l;
  boolean_T icLoad_m;
  boolean_T icLoad_n;
  boolean_T icLoad_g;
} DW_SOC_f_T;

#endif

#ifndef SOC_MDLREF_HIDE_CHILD_

typedef struct {
  ZCV_Subsystem1_SOC_T Subsystem2_e;
  ZCV_Subsystem1_SOC_T Subsystem2;
  ZCV_Subsystem1_SOC_T Subsystem1;
} ZCV_SOC_g_T;

#endif

#ifndef SOC_MDLREF_HIDE_CHILD_

typedef struct {
  ZCE_Subsystem1_SOC_T Subsystem2_e;
  ZCE_Subsystem1_SOC_T Subsystem2;
  ZCE_Subsystem1_SOC_T Subsystem1;
} ZCE_SOC_T;

#endif

#ifndef SOC_MDLREF_HIDE_CHILD_

typedef struct {
  const real_T Add;
  const real_T Add_j;
  const real_T Add_m;
  const real_T Add_i;
  const real32_T Add4;
  const real32_T Add4_j;
} ConstB_SOC_h_T;

#endif

#ifndef SOC_MDLREF_HIDE_CHILD_

struct tag_RTM_SOC_T {
  const char_T **errorStatus;
};

#endif

#ifndef SOC_MDLREF_HIDE_CHILD_

typedef struct {
  RT_MODEL_SOC_T rtm;
} MdlrefDW_SOC_T;

#endif

extern void SOC_Init(void);
extern void SOC_Start(void);
extern void SOC_Disable(void);
extern void SOC(void);
extern void SOC_initialize(const char_T **rt_errorStatus);

#ifndef SOC_MDLREF_HIDE_CHILD_

extern void SOC_IfActionSubsystem(real32_T rtu_Fitdata, real32_T *rty_Out1,
  real32_T rtp_m);
extern void SOC_IfActionSubsystem1(real32_T rtu_Fitdata1, real32_T *rty_Out2,
  real32_T rtp_m);
extern void SOC_Subsystem1(boolean_T rtu_Trigger, real32_T rtu_in1, real32_T
  rtu_in2, real32_T *rty_out1, real32_T *rty_out2, ZCE_Subsystem1_SOC_T
  *localZCE);

#endif

#ifndef SOC_MDLREF_HIDE_CHILD_

extern MdlrefDW_SOC_T SOC_MdlrefDW;

#endif

#ifndef SOC_MDLREF_HIDE_CHILD_

extern B_SOC_c_T SOC_B;
extern DW_SOC_f_T SOC_DW;
extern ZCE_SOC_T SOC_PrevZCX;

#endif
#endif

